import locmap.hierawrite
import locmap.guessdomain
import pwd
import os

def afs(node, respuser, mainuser=None):
    """
    Add respuser and mainuser if it is not the same.
    """
    adduser = '/usr/sbin/useraddcern %s'
    if os.path.isfile('/usr/sbin/useraddcern'):
        # Add user(s) if they dont exist.
        if node == 'user':
            if respuser == mainuser:
                try:
                    if pwd.getpwnam(respuser):
                        print "[INFO] Account %s already exists.\n" %respuser
                except KeyError:
                    adduser = adduser %respuser
                    os.popen(adduser).read()
                    print "[INFO] Creating AFS account %s ..\n" % respuser
            else:
                try:
                    respuser_exists = 0
                    mainuser_exists = 0
                    if pwd.getpwnam(respuser) and pwd.getpwnam(mainuser):
                        print "[INFO] Responsible user account %s already exists." % respuser
                        print "[INFO] Main user account %s already exists.\n" % mainuser
                    elif pwd.getpwnam(respuser):
                        respuser_exists = 1
                    elif pwd.getpwname(mainuser):
                        mainuser_exists = 1
                except KeyError:
                    if respuser_exists == 0:
                        adduser = adduser %respuser
                        os.popen(adduser).read()
                        print "[INFO] Created AFS account %s\n" % respuser
                    elif mainuser_exists == 0:
                        adduser = adduser % mainuser
                        add_mainuser = os.popen(adduser).read()
                        print "[INFO] Creating AFS account %s ..\n" % mainuser
        elif node == 'egroup':
            for user in respuser:
                try:
                    if pwd.getpwnam(user):
                        print "[INFO] Account %s already exists.\n" % user
                except KeyError:
                    adduser = "adduser {0}".format(user)
                    os.popen(adduser).read()
                    print "[INFO] Creating AFS account %s ..\n" % user
    else:
        print "[ERROR] Couldn't find useraddcern script."


def deploy():
    # Standard locmap model function to include all others functions, methods.
    hostname = locmap.guessdomain.guess_domain()
    hiera_config = locmap.hierawrite.HieraWrite()
    node, suser, k5user, respuser, mainuser = hiera_config.node_info(hostname)
    if node == 'egroup':
        afs(node, respuser)
    elif node == 'user':
        afs(node, respuser, mainuser)
