import locmap.xldapclient
import locmap.guessdomain
import locmap.hierawrite

def lpadmincern():
    """
    Extract the buildings and write them in Hiera
    """
    hostname = locmap.guessdomain.guess_domain()
    xldap_config = locmap.xldapclient.XldapClient()
    xldap_config.cn(hostname)
    buildings = xldap_config.mapdevice()

    if buildings:
        str_buildings = " ".join(str(x) for x in buildings)
        print "[INFO] Adding printers for building(s) %s.\n" % str_buildings
        hiera_config = locmap.hierawrite.HieraWrite()
        hiera_config.hiera_paths().lpadmin_hiera(buildings)

def deploy():
    """
    Standard locmap model function to include all others functions, methods.
    """
    lpadmincern()
